(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('s-flag-input', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["s-flag-input"] = {}, global.ng.core, global.ng.forms, global.ng.common));
})(this, (function (exports, i0, i1, i2) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);

    var data = [
        {
            countryName: "India",
            countryCode: "+91",
            flag: "https://cdn.countryflags.com/thumbs/india/flag-400.png"
        },
        {
            countryName: "Brunei",
            countryCode: "+673",
            flag: "https://cdn.countryflags.com/thumbs/brunei/flag-400.png"
        },
        {
            countryName: "Laos",
            countryCode: "+856",
            flag: "https://cdn.countryflags.com/thumbs/laos/flag-400.png"
        },
        {
            countryName: "Cambodia",
            countryCode: "+855",
            flag: "https://cdn.countryflags.com/thumbs/cambodia/flag-400.png"
        },
        {
            countryName: "Hong Kong",
            countryCode: "+852",
            flag: "https://cdn.countryflags.com/thumbs/hongkong/flag-400.png"
        },
        {
            countryName: "Indonesia",
            countryCode: "+62",
            flag: "https://cdn.countryflags.com/thumbs/indonesia/flag-400.png"
        },
        {
            countryName: "South Korea",
            countryCode: "+82",
            flag: "https://cdn.countryflags.com/thumbs/south-korea/flag-400.png"
        },
        {
            countryName: "Malaysia",
            countryCode: "+60",
            flag: "https://cdn.countryflags.com/thumbs/malaysia/flag-400.png"
        },
        {
            countryName: "Philippines",
            countryCode: "+63",
            flag: "https://cdn.countryflags.com/thumbs/philippines/flag-400.png"
        },
        {
            countryName: "Singapore",
            countryCode: "+65",
            flag: "https://cdn.countryflags.com/thumbs/singapore/flag-400.png"
        },
        {
            countryName: "Thailand",
            countryCode: "+66",
            flag: "https://cdn.countryflags.com/thumbs/thailand/flag-400.png"
        },
        {
            countryName: "Vietnam",
            countryCode: "+84",
            flag: "https://cdn.countryflags.com/thumbs/vietnam/flag-400.png"
        },
        {
            countryName: "Taiwan",
            countryCode: "+886",
            flag: "https://cdn.countryflags.com/thumbs/taiwan/flag-400.png"
        }
    ];

    var SCountryFlagInputComponent = /** @class */ (function () {
        function SCountryFlagInputComponent(_formBuilder) {
            this._formBuilder = _formBuilder;
            this.showFlags = false;
            this.countriesData = data;
            this.defaultCountry = {
                countryName: 'India',
                countryCode: '+91',
                flag: 'https://cdn.countryflags.com/thumbs/india/flag-400.png',
            };
            this.flagdata = new i0.EventEmitter();
            this.phoneNumberInput = new i0.EventEmitter();
            this.isNotValid = false;
            this.isValid = false;
        }
        SCountryFlagInputComponent.prototype.ngOnInit = function () {
            this.flagComponentForm = this._formBuilder.group({
                phonenumber: new i1.FormControl(''),
            });
            this.flagComponentForm.controls['phonenumber'].setValidators([
                i1.Validators.required,
                i1.Validators.pattern('^((\\+91-?)|0)?[0-9]{10}$'),
                i1.Validators.minLength(5),
            ]);
        };
        SCountryFlagInputComponent.prototype.onClickFlag = function () {
            this.showFlags = true;
        };
        SCountryFlagInputComponent.prototype.getCountryDetails = function (data) {
            this.flagdata.emit({ value: data });
            this.showFlags = false;
            this.defaultCountry = data;
        };
        SCountryFlagInputComponent.prototype.ngDoCheck = function () {
            this.phoneNumberInput.emit(this.flagComponentForm.controls['phonenumber']);
        };
        return SCountryFlagInputComponent;
    }());
    SCountryFlagInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SCountryFlagInputComponent, deps: [{ token: i1__namespace.FormBuilder }], target: i0__namespace.ɵɵFactoryTarget.Component });
    SCountryFlagInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: SCountryFlagInputComponent, selector: "s-country-flag-input", outputs: { flagdata: "flagdata", phoneNumberInput: "phoneNumberInput" }, ngImport: i0__namespace, template: "<div class=\"row mx-auto\">\r\n  <div class=\"col-md-2 col-sm-2 col-2 padding-0\">\r\n    <div class=\"box border-right-0\">\r\n      <div\r\n        (click)=\"onClickFlag()\"\r\n        class=\"\r\n          flag-box\r\n          border-right-0\r\n          d-flex\r\n          flex-column\r\n          justify-content-center\r\n          align-items-center\r\n        \"\r\n      >\r\n        <img\r\n          class=\"flagCala\"\r\n          [src]=\"defaultCountry.flag\"\r\n          style=\"padding-right: 10px; height: 10px;\"\r\n        />\r\n      </div>\r\n      <div id=\"myDropdown\" class=\"dropdown-content\" [hidden]=\"!showFlags\">\r\n        <div\r\n          *ngFor=\"let codes of countriesData\"\r\n          (click)=\"getCountryDetails(codes)\"\r\n          class=\"flag-detail\"\r\n        >\r\n          <img\r\n            [src]=\"codes.flag\"\r\n            style=\"padding-right: 10px; height: 10px; width: 30px;\"\r\n          />\r\n          {{ codes.countryName\r\n          }}<span class=\"cnt_cde\">{{ codes.countryCode }}</span>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"col-md-10 col-sm-10 col-10 padding-0\">\r\n    <form [formGroup]=\"flagComponentForm\">\r\n      <input\r\n      type=\"tel\"\r\n      class=\"form-control border-left-0\"\r\n      id=\"phoneflag\"\r\n      formControlName=\"phonenumber\"\r\n      minlength=\"5\"\r\n      required\r\n      placeholder=\"Your mobile number\"\r\n    />\r\n    </form>\r\n  </div>\r\n</div>\r\n\r\n  ", styles: [".padding-0{padding-right:0;padding-left:0}.dropbtn{background-color:#3498db;color:#fff;padding:16px;font-size:16px;border:none;cursor:pointer}.dropbtn:hover,.dropbtn:focus{background-color:#2980b9;cursor:pointer}.dropdown{position:relative;display:inline-block}.dropdown-content{position:absolute;z-index:2;list-style:none;text-align:left;padding:0;margin:0;box-shadow:2px 3px 15px #0a0a0a2e;background-color:#fff;border:1px solid #fff;white-space:nowrap;max-height:200px;overflow-y:scroll}.dropdown-content div{color:#000;padding:12px 11px 0 12px;text-decoration:none;display:block}.flag{height:20px;width:20px}.dropdown div:hover{background-color:#ddd;cursor:pointer}.flag-box{display:block;width:100%;height:38px;font-size:1rem;justify-content:center;font-weight:400;line-height:1.5;background-clip:padding-box;-webkit-appearance:none;-moz-appearance:none;color:#000;appearance:none;border-radius:.25rem 0 0 .25rem!important;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;background-color:#fff;background-position:20px 0;background-image:url(data:image/svg+xml;charset=US-ASCII,%3Csvg%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20viewBox%3D%220%200%20256%20448%22%20enable-background%3D%22new%200%200%20256%20448%22%3E%3Cstyle%20type%3D%22text%2Fcss%22%3E.arrow%7Bfill%3A%23424242%3B%7D%3C%2Fstyle%3E%3Cpath%20class%3D%22arrow%22%20d%3D%22M255.9%20168c0-4.2-1.6-7.9-4.8-11.2-3.2-3.2-6.9-4.8-11.2-4.8H16c-4.2%200-7.9%201.6-11.2%204.8S0%20163.8%200%20168c0%204.4%201.6%208.2%204.8%2011.4l112%20112c3.1%203.1%206.8%204.6%2011.2%204.6%204.4%200%208.2-1.5%2011.4-4.6l112-112c3-3.2%204.5-7%204.5-11.4z%22%2F%3E%3C%2Fsvg%3E%0A);background-position:right 0px center;background-repeat:no-repeat;background-size:auto 30%;border:1px solid #ced4da;padding-right:18px;padding-left:2px;-webkit-border-top-right-radius:0px;-webkit-border-bottom-right-radius:0px;-moz-border-radius-topright:0px;-moz-border-radius-bottomright:0px;border-top-right-radius:0;border-bottom-right-radius:0;border-left:3px #3e8ddd solid!important}.flag-detail:hover{background-color:#f6f6f6;padding:3px;cursor:pointer}.flag-detail{padding:3px}.box{height:100%}.border-right-0{border-right:none!important}.border-left-0{border-left:none!important;border-radius:0 .25rem .25rem 0!important}.flag-box:hover{background-color:#f2f2f2;cursor:pointer}.padding-right-10{padding-right:10px}.cnt_cde{color:#999;padding-left:10px}.input-phone{-webkit-border-top-left-radius:0px;-webkit-border-bottom-left-radius:0px;-moz-border-radius-topleft:0px;-moz-border-radius-bottomleft:0px;border-top-left-radius:0;border-bottom-left-radius:0}.flagCala{width:45px!important;padding-left:2px!important;height:25px!important;padding-top:4px!important}@media (max-width: 1187px){.flagCala{width:30px!important;padding-left:10px!important}}@media (max-width: 985px){.flagCala{width:40px!important}}@media (max-width: 445px){.flagCala{width:40px!important}}\n"], directives: [{ type: i2__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1__namespace.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i1__namespace.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1__namespace.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1__namespace.FormControlName, selector: "[formControlName]", inputs: ["disabled", "formControlName", "ngModel"], outputs: ["ngModelChange"] }, { type: i1__namespace.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { type: i1__namespace.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SCountryFlagInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 's-country-flag-input',
                        templateUrl: './s-country-flag-input.component.html',
                        styleUrls: ['./s-country-flag-input.component.css'],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.FormBuilder }]; }, propDecorators: { flagdata: [{
                    type: i0.Output
                }], phoneNumberInput: [{
                    type: i0.Output
                }] } });

    var SCountryFlagInputModule = /** @class */ (function () {
        function SCountryFlagInputModule() {
        }
        return SCountryFlagInputModule;
    }());
    SCountryFlagInputModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SCountryFlagInputModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    SCountryFlagInputModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SCountryFlagInputModule, declarations: [SCountryFlagInputComponent], imports: [i2.CommonModule,
            i1.FormsModule,
            i1.ReactiveFormsModule], exports: [SCountryFlagInputComponent] });
    SCountryFlagInputModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SCountryFlagInputModule, imports: [[
                i2.CommonModule,
                i1.FormsModule,
                i1.ReactiveFormsModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SCountryFlagInputModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            SCountryFlagInputComponent
                        ],
                        imports: [
                            i2.CommonModule,
                            i1.FormsModule,
                            i1.ReactiveFormsModule
                        ],
                        exports: [
                            SCountryFlagInputComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of flag-component
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SCountryFlagInputComponent = SCountryFlagInputComponent;
    exports.SCountryFlagInputModule = SCountryFlagInputModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=s-flag-input.umd.js.map
